VJgetTriangle <- function(gender='unknown', creep=0) {
  # the  triangle is enhanced/reduced by [creep] - need some proper implementation
  xCreep <- c(-creep, -creep, +creep)
  yCreep <- c(+creep, -creep, 0)
  if (gender == 'male') {
    return( list(xTrngle=c(2.47,2.77,8.40)+xCreep, yTrngle=c(14.9, 5.4, 10.7)+yCreep) )
  } else if (gender == 'female') {
    return( list(xTrngle=c(2.54,2.90,9.60)+xCreep, yTrngle=c(16.7, 5.2, 11.3)+yCreep) )
  } else {
    return( list(xTrngle=c(2.5,2.6,9.7)+xCreep, yTrngle=c(16.9, 4.9, 11.5)+yCreep) )
  }
}

VJtestInsideTriangle <- function( x, y, xTrngle, yTrngle) {
  # test if points x/y are inside triangle xTrngle/yTrgnle
  # by checking barycentric coordinates to be inside [0,1] each
  # returns boolean and barycentric coordinates data.frame( Insde=c(..), a=c(...), b=c(...), c=c(...)) 
  # [http://totologic.blogspot.fr/2014/01/accurate-point-in-triangle-test.html?m=1
  #a <- ((T[2,'y'] - T[3,'y'])*(x - T[3,'x']) + (T[3,'x'] - T[2,'x'])*(y - T[3,'y'])) / ((T[2,'y'] - T[3,'y'])*(T[1,'x'] - T[3,'x']) + (T[3,'x'] - T[2,'x'])*(T[1,'y'] - T[3,'y']))
  #b <- ((T[3,'y'] - T[1,'y'])*(x - T[3,'x']) + (T[1,'x'] - T[3,'x'])*(y - T[3,'y'])) / ((T[2,'y'] - T[3,'y'])*(T[1,'x'] - T[3,'x']) + (T[3,'x'] - T[2,'x'])*(T[1,'y'] - T[3,'y']))
  a <- ((yTrngle[2] - yTrngle[3])*(x - xTrngle[3]) + (xTrngle[3] - xTrngle[2])*(y - yTrngle[3])) / ((yTrngle[2] - yTrngle[3])*(xTrngle[1] - xTrngle[3]) + (xTrngle[3] - xTrngle[2])*(yTrngle[1] - yTrngle[3]))
  b <- ((yTrngle[3] - yTrngle[1])*(x - xTrngle[3]) + (xTrngle[1] - xTrngle[3])*(y - yTrngle[3])) / ((yTrngle[2] - yTrngle[3])*(xTrngle[1] - xTrngle[3]) + (xTrngle[3] - xTrngle[2])*(yTrngle[1] - yTrngle[3]))
  c <- 1 - a - b  
  return(ifelse(a>=0 & a<=1 & b>=0 & b<=1 & c>=0 & c<=1, 1, 0)) # return 1 for inside triangle
}
