# === print (large) numbers in a human readable way
VJtidyNumber <- function(x) { 
  as.character(
    ifelse(x<500,signif(x,3), 
           ifelse(x<0.5E6, paste0(signif(x/1E3,3),'k'),
                  ifelse(x<0.5E9, paste0(signif(x/1E6,3),'m'),
                      paste0(signif(x/1E6,3),'m')))))
}

# === return an entry from a list with some security around it
VJgetProtectedConfig <- function(myConfigList, entry, default='terminate', forceNumeric=FALSE) {
  if( with(myConfigList, exists(entry)) ) {
    if (forceNumeric) {
      return(as.numeric(myConfigList[entry]))
    } else
      return(as.character(myConfigList[entry]))
  } else {
    if (default=='terminate') {
      stop(paste0("FATAL ERROR: did not find mandatory config entry >", entry ,"<."))
    } else {
      return(default)
    }
  }
}

# === named data save
VJmyNamedSave <- function(x, tag, lead, directory='.') {   
  setwd(directory)
  x$tag <- tag
  tmp <- paste0(lead,' ',tag,'.txt')
  fwrite(x, file = tmp , sep="\t")   
  tmp
}


VJsignificance = function (p) {
  return ( factor(ifelse(p<0.001, '***', ifelse(p<0.01, '**', ifelse(p<0.05, '*', ifelse(p<0.1,'.','ns')))), levels=c('***','**','*','.','ns','ls')))
}
